trait Friend {
  val name : String
  def listen() { println("I'm " + name + " listening....") }  
}
class Human(val name : String) extends Friend

class Animal(val name : String)
class Dog(override val name : String) extends Animal(name) with
  Friend

def hangOutWith(friend : Friend) = {
  friend.listen()
}

val joe = new Human("Joe")
joe.listen()
hangOutWith(joe)
val buddy = new Dog("Buddy")
buddy.listen()
hangOutWith(buddy)

class Cat(override val name : String) extends Animal(name)

//val alf = new Cat("Alf")
//alf.listen()

val fluff = new Cat("Fluff") with Friend
fluff.listen()
  
println(buddy.getClass())
println(fluff.getClass())
